
clear all; clc; close all;
load data_global
plot(t,y,t,u2*1000,t,u1*500)

%%%%%%% Modelo primer orden(para revoluciones) %%%%%%%%

%tinit=4800; tfin=4827;     %Ensayo 1.1
%tinit=5540; tfin=5591;     %Ensayo 1.2
%tinit=5591; tfin=5651;     %Ensayo 1.3
%tinit=5651; tfin=5698;     %Ensayo 1.4
%tinit=5821; tfin=5853;     %Ensayo 1.5

Y=y(tinit:tfin)-y(tinit)
U1=u1(tinit:tfin)-u1(tinit)
U2=u2(tinit:tfin)-u2(tinit)
T=t(tinit:tfin)-t(tinit)
plot(T,Y,T,U1*500)

L=length(Y);

X=Y(2:L);
A=[Y(1:L-1) U1(1:L-1)];
est=inv(A'*A)*A'*X

Gd=tf(est(2),[1 -est(1)],1)
[yy,tt]=lsim(Gd,U1,T)
plot(T,Y,T,U1*500,tt,yy)
legend('Respuesta real(rpm)','Entrada(mariposa)x500','Respuesta calculada(rpm)')
title('Ensayo 1.5 (respuesta 1er orden)')
xlabel('Tiempo(s)')


est
Gd
Gc=d2c(Gd)

R2=((est'*A'*X)-((L-1)*mean(X)^2))/((X'*X)-((L-1)*mean(X)^2))

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%tinit=4355; tfin=4442;     %Ensayo 2.1
%tinit=4442; tfin=4500;     %Ensayo 2.2
%tinit=3193; tfin=3213;     %Ensayo 2.3
%tinit=3213; tfin=3238;     %Ensayo 2.4
%tinit=4708; tfin=4800;     %Ensayo 2.5
%tinit=4859; tfin=4879;     %Ensayo 2.6


Y=y(tinit:tfin)-y(tinit)
U1=u1(tinit:tfin)-u1(tinit)
U2=u2(tinit:tfin)-u2(tinit)
T=t(tinit:tfin)-t(tinit)
plot(T,Y,T,U2*1000)

L=length(Y);

X=Y(2:L);
A=[Y(1:L-1) U2(1:L-1)];
est=inv(A'*A)*A'*X

Gd=tf(est(2),[1 -est(1)],1)
[yy,tt]=lsim(Gd,U2,T)
plot(T,Y,T,U2*1000,tt,yy)
legend('Respuesta real(rpm)','Entrada(ti)x1000','Respuesta calculada(rpm)')
title('Ensayos 2.6 (respuesta 1er orden)')
xlabel('Tiempo(s)')

est
Gd
Gc=d2c(Gd)

R2=((est'*A'*X)-((L-1)*mean(X)^2))/((X'*X)-((L-1)*mean(X)^2))


%%%%%%%%%%%%%% Modelo primer orden (para lambda)%%%%%%%%%%%%%%%

%tinit=4355; tfin=4442;     %Ensayo 2.1
%tinit=4442; tfin=4500;     %Ensayo 2.2
%tinit=3193; tfin=3213;     %Ensayo 2.3
%tinit=3213; tfin=3238;     %Ensayo 2.4
%tinit=4708; tfin=4800;     %Ensayo 2.5
%tinit=4859; tfin=4879;     %Ensayo 2.6

Y=y2(tinit:tfin)-y2(tinit)
U1=u1(tinit:tfin)-u1(tinit)
U2=u2(tinit:tfin)-u2(tinit)
T=t(tinit:tfin)-t(tinit)
plot(T,Y,T,U2)

L=length(Y);

X=Y(2:L);
A=[Y(1:L-1) U2(1:L-1)];
est=inv(A'*A)*A'*X

Gd=tf(est(2),[1 -est(1)],1)
[yy,tt]=lsim(Gd,U2,T)
plot(T,Y,T,U2,tt,yy)
legend('Respuesta real(lambda)','Entrada(ti)','Respuesta calculada(lambda)')
title('Ensayo 2.6 (repuesta 1er orden para lambda)')
xlabel('Tiempo(s)')

est
Gd
Gc=d2c(Gd)

R2=((est'*A'*X)-((L-1)*mean(X)^2))/((X'*X)-((L-1)*mean(X)^2))

%%%%%%%%%% Modelo segundo orden con cero(para revoluciones)%%%%%%%%%%%%

%tinit=4800; tfin=4827;     %Ensayo 1.1
%tinit=5540; tfin=5591;     %Ensayo 1.2
%tinit=5591; tfin=5651;     %Ensayo 1.3
%tinit=5651; tfin=5698;     %Ensayo 1.4
%tinit=5821; tfin=5853;     %Ensayo 1.5

Y=y(tinit:tfin)-y(tinit)
U1=u1(tinit:tfin)-u1(tinit)
U2=u2(tinit:tfin)-u2(tinit)
T=t(tinit:tfin)-t(tinit)
plot(T,Y,T,U1*500)

L=length(Y);

X=Y(3:L);
A=[Y(2:L-1) Y(1:L-2) U1(2:L-1) U1(1:L-2)];
est=inv(A'*A)*A'*X

Gd=tf([est(3) est(4)],[1 -est(1) -est(2)],1)
[yy,tt]=lsim(Gd,U1,T)
plot(T,Y,T,U1*500,tt,yy)
legend('Respuesta real(rpm)','Entrada(mariposa)x500','Respuesta calculada(rpm)')
title('Ensayos 1.5 (respuesta 2 orden)')
xlabel('Tiempo(s)')

Gc=d2c(Gd)
[po,ce]=pzmap(Gc)

R2=((est'*A'*X)-((L-1)*mean(X)^2))/((X'*X)-((L-1)*mean(X)^2))


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%tinit=4355; tfin=4442;     %Ensayo 2.1
%tinit=4442; tfin=4500;     %Ensayo 2.2
%tinit=3193; tfin=3213;     %Ensayo 2.3
%tinit=3213; tfin=3238;     %Ensayo 2.4
%tinit=4708; tfin=4800;     %Ensayo 2.5
%tinit=4859; tfin=4879;     %Ensayo 2.6

Y=y(tinit:tfin)-y(tinit)
U1=u1(tinit:tfin)-u1(tinit)
U2=u2(tinit:tfin)-u2(tinit)
T=t(tinit:tfin)-t(tinit)
plot(T,Y,T,U2*1000)

L=length(Y);

X=Y(3:L);
A=[Y(2:L-1) Y(1:L-2) U2(2:L-1) U2(1:L-2)];
est=inv(A'*A)*A'*X

Gd=tf([est(3) est(4)],[1 -est(1) -est(2)],1)
[yy,tt]=lsim(Gd,U2,T)
plot(T,Y,T,U2*1000,tt,yy)
legend('Respuesta real(rpm)','Entrada(ti)x1000','Respuesta calculada(rpm)')
title('Ensayos 2.6 (respuesta 1er orden)')
xlabel('Tiempo(s)')

Gc=d2c(Gd)
[po,ce]=pzmap(Gc)

R2=((est'*A'*X)-((L-1)*mean(X)^2))/((X'*X)-((L-1)*mean(X)^2))



%%%%%%%%%% Modelo segundo orden con cero(para lambda)%%%%%%%%%%%%

%tinit=4800; tfin=4827;     %Ensayo 1.1
%tinit=5540; tfin=5591;     %Ensayo 1.2
%tinit=5591; tfin=5651;     %Ensayo 1.3
%tinit=5651; tfin=5698;     %Ensayo 1.4
%tinit=5821; tfin=5853;     %Ensayo 1.5

Y=y2(tinit:tfin)-y2(tinit)
U1=u1(tinit:tfin)-u1(tinit)
U2=u2(tinit:tfin)-u2(tinit)
T=t(tinit:tfin)-t(tinit)
plot(T,Y,T,U1)

L=length(Y);

X=Y(3:L);
A=[Y(2:L-1) Y(1:L-2) U1(2:L-1) U1(1:L-2)];
est=inv(A'*A)*A'*X

Gd=tf([est(3) est(4)],[1 -est(1) -est(2)],1)
[yy,tt]=lsim(Gd,U1,T)
plot(T,Y,T,U1,tt,yy)
legend('Respuesta real(lambda)','Entrada(mariposa)','Respuesta calculada(lambda)')
title('Ensayos 1.5 (respuesta 2 orden para lambda)')
xlabel('Tiempo(s)')

Gc=d2c(Gd)
[po,ce]=pzmap(Gc)

R2=((est'*A'*X)-((L-1)*mean(X)^2))/((X'*X)-((L-1)*mean(X)^2))

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%tinit=4355; tfin=4442;     %Ensayo 2.1
%tinit=4442; tfin=4500;     %Ensayo 2.2
%tinit=3193; tfin=3213;     %Ensayo 2.3
%tinit=3213; tfin=3238;     %Ensayo 2.4
%tinit=4708; tfin=4800;     %Ensayo 2.5
%tinit=4859; tfin=4879;     %Ensayo 2.6

Y=y2(tinit:tfin)-y2(tinit)
U1=u1(tinit:tfin)-u1(tinit)
U2=u2(tinit:tfin)-u2(tinit)
T=t(tinit:tfin)-t(tinit)
plot(T,Y,T,U2)

L=length(Y);

X=Y(3:L);
A=[Y(2:L-1) Y(1:L-2) U2(2:L-1) U2(1:L-2)];
est=inv(A'*A)*A'*X

Gd=tf([est(3) est(4)],[1 -est(1) -est(2)],1)
[yy,tt]=lsim(Gd,U2,T)
plot(T,Y,T,U2,tt,yy)
legend('Respuesta real(lambda)','Entrada(ti)','Respuesta calculada(lambda)')
title('Ensayos 2.6 (respuesta 2 orden para lambda)')
xlabel('Tiempo(s)')

Gc=d2c(Gd)
[po,ce]=pzmap(Gc)

R2=((est'*A'*X)-((L-1)*mean(X)^2))/((X'*X)-((L-1)*mean(X)^2))

%%%%%%%%%% Modelo segundo orden con cero(para la presin)%%%%%%%%%%%%

%tinit=4800; tfin=4827;     %Ensayo 1.1
%tinit=5540; tfin=5591;     %Ensayo 1.2
%tinit=5591; tfin=5651;     %Ensayo 1.3
%tinit=5651; tfin=5698;     %Ensayo 1.4
%tinit=5821; tfin=5853;     %Ensayo 1.5

Y=y3(tinit:tfin)-y3(tinit)
U1=u1(tinit:tfin)-u1(tinit)
U2=u2(tinit:tfin)-u2(tinit)
T=t(tinit:tfin)-t(tinit)
plot(T,Y,T,U1*10)

L=length(Y);

X=Y(3:L);
A=[Y(2:L-1) Y(1:L-2) U1(2:L-1) U1(1:L-2)];
est=inv(A'*A)*A'*X

Gd=tf([est(3) est(4)],[1 -est(1) -est(2)],1)
[yy,tt]=lsim(Gd,U1,T)
plot(T,Y,T,U1*10,tt,yy)
legend('Respuesta real(MAP)','Entrada(mariposa)x10','Respuesta calculada(MAP)')
title('Ensayos 1.5 (respuesta 2 orden para MAP)')
xlabel('Tiempo(s)')

Gc=d2c(Gd)
[po,ce]=pzmap(Gc)

R2=((est'*A'*X)-((L-1)*mean(X)^2))/((X'*X)-((L-1)*mean(X)^2))

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%tinit=4355; tfin=4442;     %Ensayo 2.1
%tinit=4442; tfin=4500;     %Ensayo 2.2
%tinit=3193; tfin=3213;     %Ensayo 2.3
%tinit=3213; tfin=3238;     %Ensayo 2.4
%tinit=4708; tfin=4800;     %Ensayo 2.5
%tinit=4859; tfin=4879;     %Ensayo 2.6

Y=y3(tinit:tfin)-y3(tinit)
U1=u1(tinit:tfin)-u1(tinit)
U2=u2(tinit:tfin)-u2(tinit)
T=t(tinit:tfin)-t(tinit)
plot(T,Y,T,U2*10)

L=length(Y);

X=Y(3:L);
A=[Y(2:L-1) Y(1:L-2) U2(2:L-1) U2(1:L-2)];
est=inv(A'*A)*A'*X

Gd=tf([est(3) est(4)],[1 -est(1) -est(2)],1)
[yy,tt]=lsim(Gd,U2,T)
plot(T,Y,T,U2*10,tt,yy)
legend('Respuesta real(MAP)','Entrada(ti)x10','Respuesta calculada(MAP)')
title('Ensayos 2.6 (respuesta 2 orden para MAP)')
xlabel('Tiempo(s)')

Gc=d2c(Gd)
[po,ce]=pzmap(Gc)

R2=((est'*A'*X)-((L-1)*mean(X)^2))/((X'*X)-((L-1)*mean(X)^2))
