
clear all; clc; close all;
load data_global_conjunta
plot(t,y,t,y2*1000,t,u1*500,t,u2*1000)

%%% Ensayos aceptables  %%%

% tinit=3390; tfin=3490; 
% tinit=3760; tfin=4070; 
% tinit=4047; tfin=4472;
% tinit=4080; tfin=4380; %Recortado del anterior%
% tinit=4180; tfin=4420; %Recortado del anterior%
% tinit=4580; tfin=4720;
% tinit=4804; tfin=5042;
 

close all; figure; hold on;
Y1=y(tinit:tfin)-y(tinit)
Y2=y2(tinit:tfin)-y2(tinit)
Y3=y3(tinit:tfin)-y3(tinit)
U1=u1(tinit:tfin)-u1(tinit)
U2=u2(tinit:tfin)-u2(tinit)
T=t(tinit:tfin)-t(tinit)
plot(T,Y1/1000,T,Y2,T,U1,T,U2)
L=length(Y2);

%Para identificar rpm:
X1=Y1(3:L);
A1=[Y1(2:L-1) Y1(1:L-2) U1(2:L-1) U1(1:L-2) U2(2:L-1) U2(1:L-2)];
est1=inv(A1'*A1)*A1'*X1
a1=est1(1); a0=est1(2); b1=est1(3); b0=est1(4); c1=est1(5); c0=est1(6);

Gd1=tf([b1 b0],[1 -a1 -a0],1);
Gd2=tf([c1 c0],[1 -a1 -a0],1);
Gd=Gd1+Gd2;
[rpm1,tt1]=lsim(Gd1,U1,T);
[rpm2,tt1]=lsim(Gd2,U2,T);
Gc1=d2c(Gd1);
Gc2=d2c(Gd2);
%Para identificar lambda:
X2=Y2(3:L);
A2=[Y2(2:L-1) Y2(1:L-2) U1(2:L-1) U1(1:L-2) U2(2:L-1) U2(1:L-2)];
est2=inv(A2'*A2)*A2'*X2
d1=est2(1); d0=est2(2); e1=est2(3); e0=est2(4); f1=est2(5); f0=est2(6);

Gd3=tf([e1 e0],[1 -d1 -d0],1);
Gd4=tf([f1 f0],[1 -d1 -d0],1);

[lambda1,tt1]=lsim(Gd3,U1,T);
[lambda2,tt1]=lsim(Gd4,U2,T);
Gc3=d2c(Gd3);
Gc4=d2c(Gd4);

%Para identificar MAP:
X3=Y3(3:L);
A3=[Y3(2:L-1) Y3(1:L-2) U1(2:L-1) U1(1:L-2) U2(2:L-1) U2(1:L-2)];
est3=inv(A3'*A3)*A3'*X3
g1=est3(1); g0=est3(2); h1=est3(3); h0=est3(4); i1=est3(5); i0=est3(6);

Gd5=tf([h1 h0],[1 -g1 -g0],1);
Gd6=tf([i1 i0],[1 -g1 -g0],1);
[MAP1,tt1]=lsim(Gd5,U1,T);
[MAP2,tt1]=lsim(Gd6,U2,T);
Gc5=d2c(Gd5);
Gc6=d2c(Gd6);

% Simulacin
close all; figure; hold on;
clear tt;clear rpm; clear lambda;clear MAP;
plot(T,Y1/1000,'color','b')
plot(T,Y2,'color',[0 0.5 0])
plot(T,Y3/10,'color',[1 0 1])
plot(T,U1,'color',[0 0.5 0])
plot(T,U2,'color',[1 0 0])
tt(1)=0; tt(2)=1;
rpm(1)=0; rpm(2)=0;
lambda(1)=0; lambda(2)=0;
MAP(1)=0; MAP(2)=0;
for k=3:L
    rpm(k)=a1*rpm(k-1)+a0*rpm(k-2)+b1*U1(k-1)+b0*U1(k-2)+c1*U2(k-1)+c0*U2(k-2);
    lambda(k)=d1*lambda(k-1)+d0*lambda(k-2)+e1*U1(k-1)+e0*U1(k-2)+f1*U2(k-1)+f0*U2(k-2);
    MAP(k)=g1*MAP(k-1)+g0*MAP(k-2)+h1*U1(k-1)+h0*U1(k-2)+i1*U2(k-1)+i0*U2(k-2);
    tt(k)=k-1;
end
plot(tt,rpm/1000,'--','color','b')
plot(tt,lambda,'--','color',[0 0.5 0])
plot(tt,MAP/10,'--','color',[1 0 1])
legend('Respuesta real(MAP)/10','Entrada(mariposa)','Entrada(ti)','Respuesta calculada(MAP)/10')
title('Ensayo conjunto X (Respuesta MAP)')
xlabel('Tiempo(s)')




